apiVersion: v1
kind: ConfigMap
metadata:
  name: argocd-notifications-cm
  namespace: openshift-gitops
data:
  service.webhook.gitlab: |
    url: https://gitlab.com
    headers:
    - name: Content-type
      value: application/json
    - name: PRIVATE-TOKEN
      value: $argocd-notifications-api-token
  trigger.on-deployed: |
    - description: Application is synced and healthy. Triggered once per commit.
      oncePer: app.status.sync.revision
      send:
      - app-deploy-success
      when: app.status.operationState != nil and app.status.operationState.phase in ['Succeeded'] and app.status.health.status == 'Healthy' and app.status.sync.revision == app.status.operationState.syncResult.revision
  template.app-deploy-success: |
    webhook:
      gitlab:
        method: POST
        path: /api/v4/projects/{{ .app.metadata.labels.gitlabid }}/deployments
        body: |
          {
             {{ $commitMessage0 := (call .repo.GetCommitMetadata .app.status.sync.revision).Message }}
             {{ $commitMessage1 := (call .strings.ReplaceAll $commitMessage0 "\n" "<NL>" ) }}
            "status": "success",
            "environment": "{{ .app.metadata.labels.environment }}",
            "sha": "{{ regexReplaceAll `.*Commit in code repo: ([0-9a-f]*)<NL>.*$$` $commitMessage1 `${1}` }}",
            "ref": "{{ .app.spec.source.targetRevision }}",
            "tag": "false"
          }
